! Copyright (C) GFD Dennou Club, 2000.  All rights reserved

subroutine ANVarPutAttrInt(var, name, value, err)
    use an_types, only: AN_VARIABLE, AN_VARIABLE_ENTRY
    use an_file, only: ANFileDefineMode
    use an_vartable, only: vtable_lookup
    use netcdf_f77, only: NF_PUT_ATT_INT, NF_NOERR, NF_DEL_ATT, &
        NF_ENOTINDEFINE, NF_INT, NF_GLOBAL
    use dc_url, only: GT_PLUS
    use dc_error
    implicit none
    type(AN_VARIABLE), intent(in):: var
    character(len = *), intent(in):: name
    type(an_variable_entry):: ent
    integer, intent(in):: value(:)
    logical, intent(out), optional:: err
    integer:: stat
continue
    stat = vtable_lookup(var, ent)
    if (stat /= NF_NOERR) goto 999
    if (size(value) == 0) then
        if (name(1:1) == GT_PLUS) then
            stat = nf_del_att(ent%fileid, NF_GLOBAL, name=name(2:))
        else
            stat = nf_del_att(ent%fileid, ent%varid, name=name)
        endif
        goto 999
    endif
    stat = ANFileDefineMode(ent%fileid)
    if (stat /= NF_NOERR) goto 999
    if (name(1:1) == GT_PLUS) then
        stat = nf_put_att_int(ent%fileid, NF_GLOBAL, name=name(2:), &
            xtype=NF_INT, len=size(value), ivals=value)
    else
        stat = nf_put_att_int(ent%fileid, ent%varid, name=name, &
            xtype=NF_INT, len=size(value), ivals=value)
    endif
    999 continue
    call StoreError(stat, 'ANVarPutAttrInt', err)
end subroutine
